from OpenGL.GL import *
from OpenGL.GLU import *
from OpenGL.GLUT import *

import wx.glcanvas as glcanvas

from display.applicationhelper import *

class OpenGLHelper:           
    def unproject(self, x, y, z = 0):
        return gluUnProject(x, y, z, glGetDoublev(GL_MODELVIEW_MATRIX), glGetDoublev(GL_PROJECTION_MATRIX), glGetIntegerv(GL_VIEWPORT))        
    
    def project(self, wx, wy, wz = 0):
        return gluProject(wx, wy, wz, glGetDoublev(GL_MODELVIEW_MATRIX), glGetDoublev(GL_PROJECTION_MATRIX), glGetIntegerv(GL_VIEWPORT))
    
glhelper = None
def getOpenGLHelper():
    global glhelper
    
    if glhelper is None:
        glhelper = OpenGLHelper()
        
    return glhelper

class GLPanel(glcanvas.GLCanvas):
    def __init__(self, parent, id, pos = wx.DefaultPosition, size = wx.DefaultSize):
        glcanvas.GLCanvas.__init__(self, parent, id, pos, size)
        
        self.Bind(wx.EVT_ERASE_BACKGROUND, self.OnEraseBackground)
        
    def OnEraseBackground(self, event):
        pass
        
    def setupViewport(self):
        size = self.GetClientSize()
        glViewport(0, 0, size.width, size.height)
        
    def clearColor(self, r = 0, g = 0, b = 0, a = 0):
        glClearColor(r, g, b, a)
        glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT)        
    
    def setUserScale(self, x, y):
        glMatrixMode(GL_PROJECTION)
        glLoadIdentity()
        gluOrtho2D(0, x, y, 0)    
        
    def clearModelViewMatrix(self):
        glMatrixMode(GL_MODELVIEW)
        glLoadIdentity()
        
    def flush(self):
        glFlush()
