from Bio.SeqFeature import FeatureLocation

class FeatureUtilities():
    def adjustForGaps(self, location, seqWithGaps):
        locStart = location.start.position
        newLocStart = None
        
        locEnd = location.end.position
        newLocEnd = locEnd
        
        featureLength = locEnd - locStart
        seqLength = len(seqWithGaps)
        
        realCounter = 0
        noGapCounter = 0
        while realCounter < seqLength:
            char = seqWithGaps[realCounter]
            if char != '-':
                if noGapCounter == locStart:
                    newLocStart = realCounter
                    break
                
                noGapCounter += 1
                
            realCounter += 1
        
        # Offset so we keep the original length of the feature, but include gaps
        newLocEnd = newLocStart    
        while featureLength > 0 and newLocEnd < seqLength:
            if seqWithGaps[newLocEnd] != '-':
                featureLength -= 1
                
            newLocEnd += 1            
        
        return FeatureLocation(newLocStart, newLocEnd)
    
featUtils = None
def getFeatureUtilities():    
    global featUtils
    if featUtils is None:
        featUtils = FeatureUtilities()
        
    return featUtils